diff --git a/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java b/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
index 847c4ccd3..419149af0 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuiGuidebook.java
@@ -11,7 +11,7 @@ import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.RenderEngine;
 import net.minecraft.client.render.entity.ItemEntityRenderer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
@@ -467,7 +467,7 @@ public class GuiGuidebook
                 GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
                 GL11.glEnable(GL11.GL_DEPTH_TEST);
-                ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(TessellatorStandard.instance, fr, re, icon, x + iconOffset + xo, y + 4, 1.0f);
+                ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, fr, re, icon, x + iconOffset + xo, y + 4, 1.0f);
                 GL11.glDisable(GL11.GL_DEPTH_TEST);
 
                 GL11.glDisable(GL12.GL_RESCALE_NORMAL);
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
index cd403ce4d..4de8c09ff 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
@@ -6,7 +6,7 @@ import net.minecraft.client.gui.GuiTooltip;
 import net.minecraft.client.gui.guidebook.GuidebookPage;
 import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.render.*;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
@@ -275,7 +275,7 @@ public class MobPage
         example.entityBrightness = 1.0F;
         GL11.glTranslatef(0.0F, example.heightOffset, 0.0F);
         EntityRenderDispatcher.instance.viewLerpYaw = 180F;
-        EntityRenderDispatcher.instance.renderEntityPreviewWithPosYaw(TessellatorStandard.instance, example, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
+        EntityRenderDispatcher.instance.renderEntityPreviewWithPosYaw(Tessellator.instance, example, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
         GL11.glPopMatrix();
         Lighting.disable();
         GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
diff --git a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
index 1fff3afdb..439ff60d4 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
@@ -7,7 +7,7 @@ import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.item.model.ItemModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.InventoryPlayer;
@@ -178,17 +178,17 @@ public class HotbarComponent
             GL11.glScalef(1.0F / f2, (f2 + 1.0F) / 2.0F, 1.0F);
             GL11.glTranslatef(-(x + 8), -(y + 12), 0.0F);
         }
-        itemModel.renderItemIntoGui(TessellatorStandard.instance, mc.fontRenderer, mc.renderEngine, itemstack, x, y, 1.0f);
+        itemModel.renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemstack, x, y, 1.0f);
         if (animProgress > 0.0F)
         {
             GL11.glPopMatrix();
         }
-        itemModel.renderItemOverlayIntoGUI(TessellatorStandard.instance, mc.fontRenderer, mc.renderEngine, itemstack, x, y, 1.0f);
+        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemstack, x, y, 1.0f);
     }
 
     private void renderItem(Minecraft mc, ItemStack itemStack, int x, int y) {
         ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
-        itemModel.renderItemIntoGui(TessellatorStandard.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, 1.0f);
-        itemModel.renderItemOverlayIntoGUI(TessellatorStandard.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, 1.0f);
+        itemModel.renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, 1.0f);
+        itemModel.renderItemOverlayIntoGUI(Tessellator.instance, mc.fontRenderer, mc.renderEngine, itemStack, x, y, 1.0f);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
index 1f154d214..b36113763 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/GuiModelViewer.java
@@ -19,7 +19,7 @@ import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.shader.PhotoModeRenderer;
 import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.client.render.shader.ShadersRenderer;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
@@ -373,7 +373,7 @@ public class GuiModelViewer extends GuiPhotoMode implements GuiListenerTextField
 
         scroll(Mouse.getDWheel());
 
-        TileEntityRenderDispatcher.instance.renderTileEntity(TessellatorStandard.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
+        TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, new TileEntity(), -0.5D, -0.75D, -0.5D, partialTick);
 
         drawStringCentered(fontRenderer, currentCategory.getCurrentDisplayInfo(I18n.getInstance()), width/2, 1, 0xffffff);
     }
diff --git a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java b/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
index a3795479e..787a0ef13 100644
--- a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
+++ b/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
@@ -10,7 +10,7 @@ import net.minecraft.client.gui.options.data.OptionsPages;
 import net.minecraft.client.gui.options.data.OptionsPageRegistry;
 import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.input.Keyboard;
@@ -250,7 +250,7 @@ public class GuiOptions
         // Draw shadows
         if (mc.theWorld == null)
         {
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             GL11.glDisable(GL_DEPTH_TEST);
             int shadowSize = 4;
             GL11.glEnable(GL_BLEND);
@@ -318,7 +318,7 @@ public class GuiOptions
 
         int scrollBarY = (int) (top + (optionsScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
 
-        TessellatorStandard t = TessellatorStandard.instance;
+        Tessellator t = Tessellator.instance;
 
         t.startDrawingQuads();
         t.setColorOpaque(0, 0, 0);
@@ -363,7 +363,7 @@ public class GuiOptions
 
         int scrollBarY = (int) (top + (pagesListScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
 
-        TessellatorStandard t = TessellatorStandard.instance;
+        Tessellator t = Tessellator.instance;
 
         t.startDrawingQuads();
         t.setColorOpaque(0, 0, 0);
@@ -469,7 +469,7 @@ public class GuiOptions
 
         if (mc.theWorld == null)
         {
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
@@ -500,7 +500,7 @@ public class GuiOptions
     {
         if (mc.theWorld == null)
         {
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
diff --git a/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java b/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
index f8b41d50e..86a3cc0b2 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
@@ -11,7 +11,7 @@ import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.Global;
@@ -126,7 +126,7 @@ public class AvailableTexturePackListComponent
         }
 
         public void render(int x, int y, int width, int mouseX, int mouseY, int index, boolean hovered) {
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             FontRenderer fontRenderer = mc.fontRenderer;
 
             setupButton(x, y, width, mouseX, mouseY);
diff --git a/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java b/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
index 0855d3aef..eb0a401c8 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
@@ -4,7 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiTexturedButton;
 import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.opengl.GL11;
@@ -105,7 +105,7 @@ public abstract class ButtonComponent
 
     protected void drawRect(int minX, int minY, int maxX, int maxY, int argb)
     {
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         GL11.glEnable(GL_BLEND);
         GL11.glDisable(GL_TEXTURE_2D);
         GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
diff --git a/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java b/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
index a651ccf00..25f24d7a3 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.lang.Language;
 import net.minecraft.core.lang.LanguageSeeker;
@@ -95,7 +95,7 @@ public class LanguagePackListComponent
 
         public void render(int x, int y, int width, int mouseX, int mouseY) {
             FontRenderer textRenderer = mc.fontRenderer;
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
 
             if (mc.gameSettings.language.value.equals(languagePack.getId())) {
                 // Draw background
diff --git a/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java b/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
index fa599a132..1a3fa786a 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
@@ -3,7 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.Global;
@@ -206,7 +206,7 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
         }
 
         public void render(SelectedTexturePackListComponent component, int x, int y, int width, int mouseX, int mouseY) {
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             FontRenderer fontRenderer = mc.fontRenderer;
 
             setupButton(x, y, width, mouseX, mouseY);
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 7580a97ab..67b2fcc20 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -99,6 +99,7 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.vignette))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.items3D))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.clouds))
+            .withComponent(new FloatOptionComponent(mc.gameSettings.cloudHeight))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.aurora))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.slimeParticles))
             .withComponent(new FloatOptionComponent(mc.gameSettings.blockOutlineWidth))
diff --git a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
index d28f1abc4..af5df7c22 100644
--- a/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
+++ b/src/main/java/net/minecraft/client/gui/paged/GuiPaged.java
@@ -4,7 +4,7 @@ import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiRenderItem;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.input.Keyboard;
@@ -223,7 +223,7 @@ public class GuiPaged
         // Draw shadows
         if (mc.theWorld == null)
         {
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             GL11.glDisable(GL_DEPTH_TEST);
             int shadowSize = 4;
             GL11.glEnable(GL_BLEND);
@@ -285,7 +285,7 @@ public class GuiPaged
 
         int scrollBarY = (int) (top + (rightScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
 
-        TessellatorStandard t = TessellatorStandard.instance;
+        Tessellator t = Tessellator.instance;
 
         t.startDrawingQuads();
         t.setColorOpaque(0, 0, 0);
@@ -330,7 +330,7 @@ public class GuiPaged
 
         int scrollBarY = (int) (top + (leftScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
 
-        TessellatorStandard t = TessellatorStandard.instance;
+        Tessellator t = Tessellator.instance;
 
         t.startDrawingQuads();
         t.setColorOpaque(0, 0, 0);
@@ -426,7 +426,7 @@ public class GuiPaged
 
         if (mc.theWorld == null)
         {
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
@@ -457,7 +457,7 @@ public class GuiPaged
     {
         if (mc.theWorld == null)
         {
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
diff --git a/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java b/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
index 18c063e48..c0ef45899 100644
--- a/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
+++ b/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.collection.Pair;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
@@ -186,7 +186,7 @@ public final class GuiPopup
 
         GL11.glDisable(GL11.GL_LIGHTING);
         GL11.glDisable(GL11.GL_FOG);
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
         if(backgroundColor == null){
diff --git a/src/main/java/net/minecraft/client/gui/popup/ListComponent.java b/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
index 35b29d246..76bed7d7a 100644
--- a/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/ListComponent.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.sound.SoundCategory;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -217,7 +217,7 @@ public class ListComponent
 
     private void drawBackground(int x, int y)
     {
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0xA0A0A0);
         tessellator.addVertex(x, y + height, 0.0D);
@@ -256,7 +256,7 @@ public class ListComponent
         scrollbarY = y + 1 + (int) (scrollAmount * scrollbarDelta);
         scrollbarX = x + getWidth() - 1 - 6;
         
-        TessellatorStandard t = TessellatorStandard.instance;
+        Tessellator t = Tessellator.instance;
 
         t.startDrawingQuads();
         t.setColorRGBA_I(0x808080, 255);
diff --git a/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java b/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
index db951725e..39dea97c6 100644
--- a/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Mouse;
@@ -145,7 +145,7 @@ public class MessageBoxComponent
 
     private void drawBackground(int x, int y)
     {
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.setColorOpaque_I(0xA0A0A0);
         tessellator.addVertex(x, y + height, 0.0D);
@@ -179,7 +179,7 @@ public class MessageBoxComponent
         scrollbarY = y + 1 + (int) (scrollAmount * scrollbarDelta);
         scrollbarX = x + getWidth() - 1 - 6;
         
-        TessellatorStandard t = TessellatorStandard.instance;
+        Tessellator t = Tessellator.instance;
 
         t.startDrawingQuads();
         t.setColorRGBA_I(0x808080, 255);
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index 7e1c92c5c..982b055f1 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -9,7 +9,7 @@ import java.io.FileWriter;
 import java.io.PrintWriter;
 
 import net.minecraft.client.option.enums.*;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+
 import org.lwjgl.opengl.Display;
 
 import com.b100.utils.ReflectUtils;
@@ -18,6 +18,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.gui.hud.HudComponents;
 import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.window.GameWindowLWJGL2;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -83,6 +84,7 @@ public class GameSettings {
 	public BooleanOption controllerSwapAB = new BooleanOption(this, "controllerSwapAB", false);
 	public BooleanOption controllerSwapXY = new BooleanOption(this, "controllerSwapXY", false);
 	public BooleanOption clouds = new BooleanOption(this, "clouds", true);
+	public FloatOption cloudHeight = new FloatOption(this, "cloudHeight", 0f);
 	public BooleanOption armorDurabilityOverlay = new BooleanOption(this, "armorDurabilityOverlay", false);
 	public BooleanOption armorProtectionOverlay = new BooleanOption(this, "armorProtectionOverlay", true);
 	public BooleanOption heldItemCountOverlay = new BooleanOption(this, "heldItemCountOverlay", false);
@@ -289,6 +291,14 @@ public class GameSettings {
 					return (timer * 5) + " seconds";
 				}
 			}
+			if (option == cloudHeight) {
+				int percent = (int)(value * 100.0f + 100.0f);
+				if (percent == 100) {
+					return trans.translateKey("options.cloudHeight.default");
+				} else {
+					return percent + "%";
+				}
+			}
 			if (value == 0.0F) {
 				return trans.translateKey("options.off");
 			} else {
@@ -412,7 +422,7 @@ public class GameSettings {
 			}
 		}
 		if(option == enableVbos){
-			TessellatorStandard.instance.setUseVBO(enableVbos.value);
+			Tessellator.instance.setUseVBO(enableVbos.value);
 			if (mc.renderGlobal != null){
 				mc.renderGlobal.loadRenderers();
 			}
diff --git a/src/main/java/net/minecraft/client/render/ChunkRenderer.java b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
index a75ad9c5b..6fb1c0f7a 100644
--- a/src/main/java/net/minecraft/client/render/ChunkRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ChunkRenderer.java
@@ -5,8 +5,7 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.entity.ItemEntityRenderer;
-import net.minecraft.client.render.tessalator.Tessellator;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
@@ -313,6 +312,6 @@ public class ChunkRenderer
 
     static 
     {
-        tessellator = TessellatorStandard.instance;
+        tessellator = Tessellator.instance;
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/EffectRenderer.java b/src/main/java/net/minecraft/client/render/EffectRenderer.java
index 08171fbc0..23d1ef3cb 100644
--- a/src/main/java/net/minecraft/client/render/EffectRenderer.java
+++ b/src/main/java/net/minecraft/client/render/EffectRenderer.java
@@ -5,8 +5,8 @@ import java.util.*;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.entity.fx.EntityDiggingFX;
 import net.minecraft.client.entity.fx.EntityFX;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
 import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -15,7 +15,7 @@ import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
 //            EntityFX, Entity, MathHelper, RenderEngine, 
-//            TessellatorStandard, Block, EntityDiggingFX, World
+//            Tessellator, Block, EntityDiggingFX, World
 
 public class EffectRenderer
 {
@@ -97,7 +97,7 @@ public class EffectRenderer
                 texture = TextureRegistry.itemAtlas.getTextureId();
             }
             GL11.glBindTexture(GL11.GL_TEXTURE_2D, texture);
-            TessellatorStandard tessellator = TessellatorStandard.instance;
+            Tessellator tessellator = Tessellator.instance;
             tessellator.startDrawingQuads();
             for(int k = 0; k < fxLayers[i].size(); k++)
             {
@@ -116,7 +116,7 @@ public class EffectRenderer
         {
             return;
         }
-        TessellatorStandard tessellator = TessellatorStandard.instance;
+        Tessellator tessellator = Tessellator.instance;
         for(int i = 0; i < fxLayers[layerId].size(); i++)
         {
             EntityFX entityfx = (EntityFX)fxLayers[layerId].get(i);
diff --git a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
index f9acfa263..3be1a3e85 100644
--- a/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
@@ -51,7 +51,7 @@ import net.minecraft.client.render.model.ModelSlime;
 import net.minecraft.client.render.model.ModelSquid;
 import net.minecraft.client.render.model.ModelWolf;
 import net.minecraft.client.render.model.ModelZombie;
-import net.minecraft.client.render.tessalator.Tessellator;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityBobber;
diff --git a/src/main/java/net/minecraft/client/render/FogManager.java b/src/main/java/net/minecraft/client/render/FogManager.java
index d262f9357..cbec689bb 100644
--- a/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/src/main/java/net/minecraft/client/render/FogManager.java
@@ -39,6 +39,10 @@ public class FogManager {
         this.mc = mc;
     }
 
+    public void setFogColor(float r, float g, float b, float a) {
+        glFog(GL_FOG_COLOR, buffer(r, g, b, a));
+    }
+
     public void updateBrightness() {
         fogBrightnessOld = fogBrightness;
 
diff --git a/src/main/java/net/minecraft/client/render/FontRenderer.java b/src/main/java/net/minecraft/client/render/FontRenderer.java
index c9e042fd1..8c6b9ff58 100644
--- a/src/main/java/net/minecraft/client/render/FontRenderer.java
+++ b/src/main/java/net/minecraft/client/render/FontRenderer.java
@@ -2,7 +2,7 @@ package net.minecraft.client.render;
 
 import net.minecraft.client.lang.text.Text;
 import net.minecraft.client.option.GameSettings;
-import net.minecraft.client.render.tessalator.TessellatorStandard;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.client.util.helper.Colors;
@@ -417,9 +417,9 @@ public class FontRenderer {
                     ++var9;
                 }
 
-                TessellatorStandard var7;
+                Tessellator var7;
                 if(this.strikethroughStyle) {
-                    var7 = TessellatorStandard.instance;
+                    var7 = Tessellator.instance;
                     GL11.glDisable(GL11.GL_TEXTURE_2D);
                     var7.startDrawingQuads();
                     var7.addVertex(this.posX, this.posY + (float)(this.fontHeight / 2), 0.0D);
@@ -431,7 +431,7 @@ public class FontRenderer {
                 }
 
                 if(this.underlineStyle) {
-                    var7 = TessellatorStandard.instance;
+                    var7 = Tessellator.instance;
                     GL11.glDisable(GL11.GL_TEXTURE_2D);
                     var7.startDrawingQuads();
                     int var8 = this.underlineStyle ? -1 : 0;
